---
title: Interface development guide
slug: Mozilla/Developer_guide/Interface_development_guide
tags:
- XPCOM
---
<p><a href="/en/XPCOM_interface_reference" title="en/XPCOM interface reference">XPCOM interfaces</a> define classes that
  are implemented to provide key functionality in the Mozilla platform. The articles linked from this page offer
  guidelines for developing and using these interfaces.</p>
<table class="topicpage-table">
  <tbody>
    <tr>
      <td>
        <h3 id="Documentation">Documentation</h3>
        <dl>
          <dt><a href="/en/XPIDL" title="en/XPIDL">XPIDL</a></dt>
          <dd>The XPCOM Interface Description Language is used to specify XPCOM interface classes.</dd>
          <dt><a href="/En/Developer_Guide/Interface_development_guide/IDL_interface_rules"
              title="en/IDL interface rules">IDL interface rules</a></dt>
          <dd>Design guidelines and rules when creating and changing XPCOM interfaces. If you're going to be changing an
            interface, be sure to read these first!</dd>
          <dt><a href="/En/Developer_Guide/Interface_development_guide/Commenting_IDL_for_better_documentation"
              title="En/Developer Guide/Interface development guide/Commenting IDL for better documentation">Commenting
              IDL for better documentation</a></dt>
          <dd>A guide explaining how to properly comment your interface's IDL in order to ensure that not only can
            others understand your interface, but to ensure that the documentation here on MDC is as accurate as
            possible.</dd>
        </dl>
        <p><span class="alllinks"><a class="internal" href="/Special:Tags?tag=XPCOM" title="Special:Tags?tag=XPCOM">View
              all pages tagged with "XPCOM"...</a></span></p>
      </td>
      <td>
        <h3 id="Community">Community</h3>
        <p>View Mozilla embedding forums...</p>
        <p>{{ DiscussionList("dev-embedding", "mozilla.dev.embedding") }}<br> <span class="alllinks"><br> </span></p>
        <h3 id="Related_Topics">Related Topics</h3>
        <p><a href="/en/JavaScript" title="en/JavaScript">JavaScript</a>, <a href="/en/XPCOM"
            title="en/XPCOM">XPCOM</a>, <a href="/En/Developer_Guide" title="en/Developing_Mozilla">Developing
            Mozilla</a></p>
      </td>
    </tr>
  </tbody>
</table>